from starlette.testclient import TestClient

table_defintion_json = {
    "sheets": [
        {
            "title": "TestTable",
            "columns": [{"name": "Col1", "type": "string"}, {"name": "Col2", "type": "float"}, {"name": "Col3", "type": "boolean"}],
            "rows": [{"Col1": "test1", "Col2": 0.5, "Col3": False}, {"Col1": "test2", "Col2": None, "Col3": True}],
        }
    ]
}

# this is the xlsx representation of the table_defintion_json above
xlsx_from_json_result = b"PK\x03\x04\x14\x00\x00\x00\x08\x00\ti\x8cXFZ\xc1\x0c\x82\x00\x00\x00\xb1\x00\x00\x00\x10\x00\x00\x00docProps/app.xmlM\x8eM\x0b\xc20\x10D\xffJ\xe9\xddnU\xf0 1 \xd4\xa3\xe0\xc9{H76\x90dCv\x85\xfc|S\xc1\x8f\xdb<\xde0\x8c\xba\x15\xcaX\xc4#w5\x86\xc4\xa7~\x11\xc9G\x00\xb6\x0bF\xc3C\xd3\xa9\x19G%\x1aiX\x1e@\xcey\x8b\x13\xd9g\xc4$\xb0\x1b\xc7\x03`\x15L3\xce\x9b\xfc\x1d\xec\xb5:\xe7\x1c\xbc5\xe2)\xe9\xab\xb7\x85\x98\x9ct\x97j1(\xf8\x97k\xf3\x8e\x85\xd7\xbc\x1f\xb6o\xf9a\x05\xbf\x93\xfa\x05PK\x03\x04\x14\x00\x00\x00\x08\x00\ti\x8cX\xddR\xb3\x7f\xea\x00\x00\x00\xcb\x01\x00\x00\x11\x00\x00\x00docProps/core.xml\xa5\x91\xc1j\xc30\x0c\x86_\xa5\xe4\x9e(N\xcb(\xc6\xf5ec\xa7\x16\x06+l\xecfd\xb5\r\x8b\x13ck$}\xfb9Y\x9bnl\xb7\x1d\xad\xff\xd3'\t+\xf4\x12\xbb@O\xa1\xf3\x14\xb8\xa6\xb8\x18\\\xd3F\x89~\x93\x9d\x98\xbd\x04\x88x\"gb\x91\x886\x85\x87.8\xc3\xe9\x19\x8e\xe0\r\xbe\x9b#AU\x96w\xe0\x88\x8d5l`\x14\xe6~6f\x17\xa5\xc5Y\xe9?B3\t,\x025\xe4\xa8\xe5\x08\xa2\x10pc\x99\x82\x8b\x7f6L\xc9L\x0e\xb1\x9e\xa9\xbe\xef\x8b~9qi#\x01\xaf\xbb\xed\xf3\xb4|^\xb7\x91M\x8b\x94ieQb \xc3]\xd0\xe3E\xfe<4\n\xbe\x15\xd5e\xf6W\x81\xec\"M\x90|\xf6\xb4\xc9\xae\xc9\xcb\xf2\xfea\xff\x98\xe9\xaa\xacVy\xb9\xcaE\xb5\x17B\x96k)\xd6o\xa3\xebG\xffM\xe8:[\x1f\xea\x7f\x18\xaf\x02\xad\xe0\xd7\xbf\xe9OPK\x03\x04\x14\x00\x00\x00\x08\x00\ti\x8cX\x99\\\x9c#\x10\x06\x00\x00\x9c'\x00\x00\x13\x00\x00\x00xl/theme/theme1.xml\xedZ[s\xda8\x14~\xef\xaf\xd0xg\xf6m\x0b\xc66\x81\xb6\xb4\x13siv\xdb\xb4\x99\x84\xedN\x1f\x85\x11X\x8dlyd\x91\x84\x7f\xbfG6\x10\xcb\x96\r\xed\x92M\xba\x9b<\x04,\xe9\xfb\xceEG\xe7\xe88y\xf3\xee.b\xe8\x86\x88\x94\xf2x`\xd9/\xdb\xd6\xbb\xb7/\xde\xe0W2$\x11A0\x19\xa7\xaf\xf0\xc0\n\xa5L^\xb5Zi\x00\xc38}\xc9\x13\x12\xc3\xdc\x82\x8b\x08Kx\x14\xcb\xd6\\\xe0[\x1a/#\xd6\xea\xb4\xdb\xddV\x84il\xa1\x18Gd`}^,h@\xd0TQZo_ \xb4\xe5\x1f3\xf8\x15\xcbT\x8de\xa3\x01\x13WA&\xb9\x88\xb4\xf2\xf9l\xc5\xfc\xda\xde>e\xcf\xe9:\x1d2\x81n0\x1bX \x7f\xceo\xa7\xe4NZ\x88\xe1T\xc2\xc4\xc0jg?Vk\xc7\xd1\xd2H\x80\x82\xc9}\x94\x05\xbaI\xf6\xa3\xd3\x15\x082\r;:\x9dX\xcev|\xf6\xc4\xed\x9f\x8c\xca\xdat4m\x1a\xe0\xe3\xf1x8\xb6\xcb\xd2\x8bp\x1c\x04\xe0Q\xbb\x9e\xc2\x9d\xf4l\xbf\xa4A\t\xb4\xa3i\xd0d\xd8\xf6\xda\xae\x91\xa6\xaa\x8dSO\xd3\xf7}\xdf\xeb\x9bh\x9c\n\x8d[O\xd3kw\xdd\xd3\x8e\x89\xc6\xad\xd0x\r\xbe\xf1O\x87\xc3\xae\x89\xc6\xab\xd0t\xebi&'\xfd\xaek\xa4\xe9\x16hBF\xe3\xebz\x12\x15\xb5\xe5@\xd3 \x00Xpv\xd6\xcc\xd2\x03\x96^)\xfau\x94\x1a\xd9\x1d\xbb\xddA\\\xf0X\xee9\x89\x11\xfe\xc6\xc5\x04\xd6i\xd2\x19\x964Fr\x9d\x90\x05\x0e\x007\xc4\xd1LP|\xafA\xb6\x8a\xe0\xc2\x92\xd2\\\x90\xd6\xcf)\xb5P\x1a\x08\x9a\xc8\x81\xf5G\x82!\xc5\xdc\xaf\xfd\xf5\x97\xbb\xc9\xa43z\x9d}:\xcek\x94\x7fi\xab\x01\xa7\xed\xbb\x9b\xcf\x93\xfcs\xe8\xe4\x9f\xa7\x93\xd7MB\xcep\xbc,\t\xf1\xfb#[a\x87'n;\x13r:\x1cgB|\xcf\xf6\xf6\x91\xa5%2\xcf\xef\xf9\n\xebN<g\x1fV\x96\xb0]\xcf\xcf\xe4\x9e\x8cr#\xbb\xdd\xf6X}\xf6OGn#\xd7\xa9\xc0\xb3\"\xd7\x94F$E\x9f\xc8-\xba\xe4\x118\xb5I\r2\x13?\x08\x9d\x86\x98jP\x1c\x02\xa4\t1\x96\xa1\x86\xf8\xb4\xc6\xac\x11\xe0\x13}\xb7\xbe\x08\xc8\xdf\x8d\x88\xf7\xabo\x9a=W\xa1XI\xda\x84\xf8\x10F\x1a\xe2\x9cs\xe6s\xd1l\xfb\x07\xa5F\xd1\xf6U\xbc\xdc\xa3\x97X\x15\x01\x97\x18\xdf4\xaa5,\xc5\xd6x\x95\xc0\xf1\xad\x9c<\x1d\x13\x12\xcd\x94\x0b\x06A\x86\x97$&\x12\xa99~MH\x13\xfe+\xa5\xda\xfe\x9c\xd3@\xf0\x94/$\xfaJ\x91\x8fi\xb3#\xa7t&\xcd\xe83\x1a\xc1F\xaf\x1bu\x87h\xd2<z\xfe\x05\xf9\x9c5\n\x1c\x91\x1b\x1d\x02g\x1b\xb3F!\x84i\xbb\xf0\x1e\xaf$\x8e\x9a\xad\xc2\x11+B>b\x196\x1ar\xb5\x16\x81\xb6q\xa9\x84`Z\x12\xc6\xd1xN\xd2\xb4\x11\xfcY\xac5\x93>`\xc8\xec\xcd\x91u\xce\xd6\x91\x0e\x11\x92^7B>b\xce\x8b\x90\x11\xbf\x1e\x868J\x9a\xed\xa2qX\x04\xfd\x9e^\xc3I\xc1\xe8\x82\xcbf\xfd\xb8~\x86\xd53l,\x8e\xf7G\xd4\x17J\xe4\x0f&\xa7?\xe924\x07\xa3\x9aY\t\xbd\x84Vj\x9f\xaa\x874>\xa8\x1e2\n\x05\xf1\xb9\x1e>\xe5zx\n7\x96\xc6\xbcP\xae\x82{\x01\xff\xd1\xda7\xc2\xab\xf8\x82\xc09\x7f.}\xcf\xa5\xef\xb9\xf4=\xa1\xd2\xb77#}g\xc1\xd3\x8b[\xdeFn[\xc4\xfb\xae1\xda\xd74.(cWr\xcd\xc8\xc7T\xaf\x93)\xd89\x9f\xc0\xec\xfdh>\x9e\xf1\xed\xfa\xd9$\x84\xaf\x9aY-#\x16\x90K\x81\xb3A$\xb8\xfc\x8b\xca\xf0*\xc4\t\xe8d[%\t\xcbT\xd3e7\x8a\x12\x9eB\x1bn\xe9S\xf5J\x95\xd7\xe5\xaf\xb9(\xb8<[\xe4\xe9\xaf\xa1t>,\xcf\xf9<_\xe7\xb4\xcd\x0b3C\xb7rK\xea\xb6\x94\xbe\xb5&8J\xf4\xb1\xccpN\x1e\xcb\x0c;g<\x92\x1d\xb6w\xa0\x1d5\xfb\xf6]v\xe4#\xa50S\x97C\xb8\x1aB\xbe\x03m\xba\x9d\xdc:8\x9e\x98\x91\xb9\n\xd3R\x90o\xc3\xf9\xe9\xc5x\x1a\xe29\xd9\x04\xb9}\x98Wm\xe7\xd8\xd1\xd1\xfb\xe7\xc1Q\xb0\xa3\xef<\x96\x1d\xc7\x88\xf2\xa2!\xee\xa1\x86\x98\xcf\xc3C\x87y{_\x98g\x95\xc6P4\x14ml\xac$,F\xb7`\xb8\xd7\xf1,\x14\xe0d`-\xa0\x07\x83\xafQ\x02\xf2RU`1[\xc6\x03+\x90\xa2|L\x8cE\xe8p\xe7\x97\\_\xe3\xd1\x92\xe3\xdb\xa6e\xb5n\xaf)w\x19m\"R9\xc2i\x98\x13g\xab\xca\xdee\xb1\xc1U\x1d\xcfU[\xf2\xb0\xbej=\xb4\x15N\xcf\xfeY\xad\xc8\x9f\x0c\x11N\x16\x0b\x12Hc\x94\x17\xa6J\xa2\xf3\x19S\xbe\xe7+I\xc4U8\xbfE3\xb6\x12\x97\x18\xbc\xe3\xe6\xc7qNS\xb8\x12v\xb6\x0f\x022\xb9\xbb9\xa9ze1g\xa6\xf2\xdf-\x0c\t,[\x88Y\x12\xe2M]\xed\xd5\xe7\x9b\x9c\xaez\"v\xfa\x97w\xc1`\xf2\xfdp\xc9G\x0f\xe5;\xe7_\xf4]C\xae~\xf6\xdd\xe3\xfan\x93;HL\x9cy\xc5\x11\x01tE\x02#\x95\x1c\x06\x16\x172\xe4P\xee\x92\x90\x06\x13\x01\xcd\x94\xc9D\xf0\x02\x82d\xa6\x1c\x80\x98\xfa\x0b\xbd\xf2\x0c\xb9)\x15\xce\xad>9\x7fE,\x83\x86N^\xd2%\x12\x14\x8a\xb0\x0c\x05!\x17r\xe3\xef\xef\x93jw\x8c\xd7\xfa,\x81m\x84T2d\xd5\x17\xcaC\x89\xc1=3rC\xd8T%\xf3\xae\xda&\x0b\x85\xdb\xe2T\xcd\xbb\x1a\xbe&`K\xc3zn\x9d-'\xff\xdb^\xd4=\xb4\x17=F\xf3\xa3\x99\xe0\x1e\xb3\x87s\x9bz\xb8\xc2E\xac\xffX\xd6\x1e\xf92\xdf9p\xdb:\xde\x03^\xe6\x13,C\xa4~\xc1}\x8a\x8a\x80\x11\xabb\xbe\xba\xafO\xf9%\x9c;\xb4{\xf1\x81 \x9b\xfc\xd6\xdb\xa4\xf6\xdd\xe0\x0c|\xd4\xabZ\xa5d+\x11?K\x07|\x1f\x92\x06c\x8c[\xf44_\x8f\x14b\xad\xa6\xb1\xad\xc6\xda1\x0cy\x80X\xf3\x0c\xa1f8\xdf\x87E\x9a\x1a3\xd5\x8b\xac9\x8d\noA\xd5@\xe5?\xdb\xd4\rh\xf6\r4\x1c\x91\x05^1\x99\xb66\xa3\xe4N\n<\xdc\xfe\xef\r\xb0\xc2\xc4\x8e\xe1\xed\x8b\xbf\x01PK\x03\x04\x14\x00\x00\x00\x08\x00\ti\x8cX\x04q\xaa\xb1n\x01\x00\x00F\x03\x00\x00\x18\x00\x00\x00xl/worksheets/sheet1.xml\x85S\xddN\x830\x14~\x15\xc2\x03\xac\x0c25\x06H\xdc\x8c\xd1\x0b\x93e\x8bz]\xe0\x00\xcdZ\x8a\xed\xd9\xd0\xb7\xb7-[\xc3\xcctW\x9c\x9f~?\xa7\xa7\xa4\x83T;\xdd\x02`\xf0%x\xa7\xb3\xb0E\xec\xef\t\xd1e\x0b\x82\xea\x99\xec\xa13\x9dZ*A\xd1\xa4\xaa!\xbaW@+\x07\x12\x9c\xc4QtC\x04e]\x98\xa7\xae\xb6Vy*\xf7\xc8Y\x07k\x15\xe8\xbd\x10T}/\x81\xcb!\x0b\xe7\xe1\xa9\xb0aM\x8b\xae@\xf2\xb4\xa7\rl\x01\xdfz\x030)\xf1<.xg0\xe8I\x1cX\xcf\x85\x94;\x9b\xbcTY\x18Yi\xe0P\"\x93]@\xcd\xe7\x00+\xe0<\x0b\x1f\xac\xe0\xa7\x82z\x0c=\xb7EN\xe3\x13\xfd\x93\x1b\xd3\xb8(\xa8\x86\x95\xe4\x1f\xac\xc26\x0b\xef\xc2\xa0\x82\x9a\xee9n\xe4\xf0\x0cG\xeb\x0bG\xe8p\x8f\x14i\x9e*9\x04\xca\xce\x94\xa7\xa5\r\x9c\xba\x9b\xd1\x1cg\x9d\xbd\x91-*\xd3eF\x0fs\xc3?O\t\x1a\x1f6'\xe5\x11\xb5\xbc\x8a\x8a/\xa0VWQ\xc99\x8a\x18\xb7\xder\xec-\xc7\x7f\x10 h\xbc\xe8v\x04\xd8\xed\x1f\xf2h\xb6H\xc9a\xeaj\xec\x16c\xd7\xf7\xce\xb4\x13\xaf\x9d\xfc\xa3}q\xe6d\xc2>\xff\xc5N&\x8b\xb1\xef\xeb\x95\xaa\x86u:\xe0P\x1bL4\xbb5\xebS\xe3&\xc7\x04e\xef\xee\xaf\x90\x88R\xb8\xb05\xef\x1c\x94=`\xfa\xb5\x94\xe8\x13\xfb\x92\xfc\xaf\x93\xff\x00PK\x03\x04\x14\x00\x00\x00\x08\x00\ti\x8cX\x18\xb4\x1cWd\x02\x00\x00\xc0\n\x00\x00\r\x00\x00\x00xl/styles.xml\xddV\xdb\x8e\x9b0\x10\xfd\x15\xe4\x0f(KPQ\xa8B\x1e\x8a\x14\xa9R[\xad\xb4\xfb\xd0W\x13Lb\xc9\x17j\xcc*\xe9\xd7\xd7c;\x81\xecfX\xb5\xeaSA\x81\x999>s\xf3Xd3\xd8\xb3`OG\xc6lr\x92B\r\x159Z\xdb\x7fJ\xd3a\x7fd\x92\x0e\x1ft\xcf\x94C:m$\xb5N5\x87t\xe8\r\xa3\xed\x00$)\xd2\xd5\xc3C\x91J\xca\x15\xd9n\xd4(w\xd2\x0e\xc9^\x8f\xcaV\xe4\x81$\xe9v\xd3i5\x99V$\x18\xdcZ*Y\xf2BEEj*xcxXL%\x17\xe7`_y\xcb^\x0bm\x12\xeb\xb2a\x15\xc9\xbci\xf8\x15\x16dQ\x85T\xa3/\xc9\x956\xde\x9a\x860\xe1\xd9D\xc2\x1c\xf1\xaf\xc1\xad\xe0B\xdc\xe6\xe7\x0c\xdbMO\xadeF\xed\x9c\x12H\xde\xfa\x16\x8b\xf2\xf3\xb9w\xf9\x1d\x0c=g\xab\x8fd\xc6\xf0/\x17\xa6\xd1\xa6e\xe6\x1a(#\x17\xd3v#Xg\x81a\xf8\xe1\xe8\x05\xab{x5\xdaZ-Aj9=hEC&\x17Z\x14\x9c\xef=\x13\xe2\tv\xf2Gw\x13\xe0\xd4%aK\xbe\xb4~7\xa0\xe2\x8b\xe8\xb2\x8abp\x13\x15\x080w\x17\x9c\xcf\xfc\xae\xfe\xceo\xcf_\xb4\xfd<\xba\x82\x94\xd7\x7f\x8e\xda\xb2G\xc3:~\xf2\xfa\xa9\x9b\x12\xc0\xdcg\xff\xc6}\x1a+\x9a\xf5\xed\xa6kWk\x023Z\x91\xef0\xfbb\xe6\xa3\x19\xb9\xb0\\E\xed\xc8\xdb\x96\xa9\xb7\xcds\xfe-m\xdc\xe9\xba\t\xe0V\xb5\xac\xa3\xa3\xb0\xcfW\xb0\"\x93\xfc\x8d\xb5|\x94\xe5u\xd5#\x14\x16WM\xf2W\x98\x94\xac\x98\x0e\x88\x0b\xc6U\xcbN\xac\xad\xa3j\x0e\x8d\x17\x13'\xb8\xb0\xf1\xf2\x8c\xd7\xd0\xce_\x08\x84\xb2\x02\x88@\x00\xa2\xb1\xd04PV\xe0\xa1\xb1\xfe\xc7\xba\xd6x]\x01D3\\\xdf\x87\xd68k\x8d\xb3\x02\xef.T\xfb\x1b\x8d\x85\xb0Jw!%\x97e\x9e\x17\x05\xda\xde\xba\xbe\x9fF\x8d\xf6\xb0(\xe0\x878D3\x04\x0e\x1a\x0b\xa2\xfdi\xe7\x17\x06`al\xde\x99\rt\x97\x17\xc7\x06-yaD\xd1\x92\x17:\x0f\x10\xd2C\xe0\x94%2\x00h,\xe0\xa0\x9b\x82N\x14$\x81\xc4\x82QCXy\x0e\xfb\x8cf\x88\x1e\xf3\x05\xa8,Q\x08\x86\x14\x99\xde\xa2\xc0\x1aU\xc0\x8d\xec\x17z\x88\xf2\xbc,\x11\x08@$\x8d<G!8\xb0\x0b\x10\x9a\x06$\x82By\x1e>\xa4\xaf\xbeg\xe9\xe5;\x97N\xffY\xb7\xbf\x01PK\x03\x04\x14\x00\x00\x00\x08\x00\ti\x8cX\xb7G\xeb\x8a\xc0\x00\x00\x00\x16\x02\x00\x00\x0b\x00\x00\x00_rels/.rels\x9d\x92Kn\x021\x0c@\xaf\x12e_L\xa9\xc4\x021\xac\xd8\xb0C\x88\x0b\xb8\x89\xe7\xa3\x99\xc4\x91c\xc4\xf4\xf6\x8d\xd8\xc0 h\x11K\xff\x9e\x9e-\xaf\x0f4\xa0v\x1cs\xdb\xa5l\xc60\xc4\\\xd9V5\xad\x00\xb2k)`\x9eq\xa2X*5K@-\xa14\x90\xd0\xf5\xd8\x10,\xe6\xf3%\xc8-\xc3n\xd6\xb7Ls\xfcI\xf4\n\x91\xeb\xbas\xb4ew\n\x14\xf5\x01\xf8\xae\xc3\x9a#JCZ\xd9q\x803K\xff\xcd\xdc\xcf\n\xd4\x9a\x9d\xaf\xac\xec\xfc\xa75\xf0\xa6\xcc\xf3\xf5 \x90\xa2GEp,\xf4\x91\xa4L\x8bv\x94\xaf>\x9e\xdd\xbe\xa4\xf3\xa5cb\xb4x\xdf\xe8\xff\xf3\xd0\xa8\x14=\xf9\xbf\x9d0\xa5\x89\xd2\xd7E\t&o\xb0\xf9\x05PK\x03\x04\x14\x00\x00\x00\x08\x00\ti\x8cXg\xc5t\x873\x01\x00\x00,\x02\x00\x00\x0f\x00\x00\x00xl/workbook.xml\x8d\x90\xd1N\xc30\x0cE\x7f\xa5\xca\x07\xd0n\x82IL+/L\xc0$\x04\x88M{O[w\xb5\x96\xc4\x95\xe3m\xb0\xaf'I)L\xe2\x85\xa7\xc4\xd7\xd6\xf1\xbd^\x9c\x88\xf7\x15\xd1>\xfb\xb0\xc6\xf99\x97\xaa\x13\xe9\xe7y\xee\xeb\x0e\xac\xf6W\xd4\x83\x0b\xbd\x96\xd8j\t%\xefrj[\xacaI\xf5\xc1\x82\x93|Z\x14\xb3\x9c\xc1hAr\xbe\xc3\xde\xab\x81\xf6\x1f\x96\xef\x19t\xe3;\x00\xb1f@Y\x8dN\xdd-Fgo\x9c\xe5\x97\x15\t\xd4qST\xa3\xb2E8\xf9\xdf\x81XfG\xf4X\xa1A\xf9,U\xfa\x1bP\x99E\x87\x16\xcf\xd0\x94\xaaP\x99\xef\xe8\xf4D\x8cgr\xa2\xcd\xbaf2\xa6T\x93\xa1\xb1\x05\x16\xac\xff\xc8\xebhs\xa3+\x9f\x14\xd1\xd5{\xcc\\\xaaY\x11\x80-\xb2\x974\x91\xf8:\x98<B\x18\x1e\xaa\x83\xd0\x03\x1a\x01^j\x81G\xa6C\x8fn\x970!F~\x91#\x9db|3\xa7-\x94j\x03>\xae\x8d!\x92\xbcj\x06K\x12X\x17\x01y\x8e\xa1\xc1\xab\xe6\x9b:\xa2\x1ah\xd1A\xf3\x12X>6B\xb0:\\5>\x894\xbd\xbe\x99\xdc\x86\x00\x07c\xee\x83\xf6\xea\x9eI7?\xde\xc6\xc3\xde}\x01PK\x03\x04\x14\x00\x00\x00\x08\x00\ti\x8cX3\xeb\xe3\xba\xad\x00\x00\x00\xfb\x01\x00\x00\x1a\x00\x00\x00xl/_rels/workbook.xml.rels\xb5\x91=\x0e\x830\x0c\x85\xaf\x12\xe5\x00\x18\xa8\xd4\xa1\x02\xa6.\xac\x15\x17\x88\x82\xf9\x11\x81D\xb1\xab\xc2\xed\x1b\xc1\x00H\x1d\xba0Y\xcf\x96\xbf\xf7dg/4\x8a{;Q\xd7;\x12\xf3h&\xcae\xc7\xec\x1e\x00\xa4;\x1c\x15E\xd6\xe1\x14&\x8d\xf5\xa3\xe2 }\x0bN\xe9A\xb5\x08i\x1c\xdf\xc1\x1f\x19\xb2\xc8\x8eLQ-\x0e\xff!\xda\xa6\xe95>\xad~\x8f8\xf1\x0f0|\xac\x1f\xa8Cd)*\xe5[\xe4\\\xc2l\xf66\xc1Z\x92(\x90\xa5(\xeb\\\xfa\xb2N\xa4\x80\xcb\x12\x11/\x06i\x8f\xb3\xe9\x93\x7fz\xa5?\x87]\xdc\xedW\xb95\xcfG\xb8\xad!\xe0\xf4\xeb\xe2\x0bPK\x03\x04\x14\x00\x00\x00\x08\x00\ti\x8cX\x9b\x86B\x84\x1b\x01\x00\x00\xd7\x03\x00\x00\x13\x00\x00\x00[Content_Types].xml\xad\x93\xcfN\xc30\x0c\xc6_\xa5\xeauj38p@\xeb.\x8c+\xec\xc0\x0b\x84\xc4]\xa3\xe6\x9fboto\x8f\xdb\xb2J\xa0\xb1\r\x95K\xa3\xc6\xf6\xf7s\xfc%\xab\xb7c\x04\xcc:g=VyC\x14\x1f\x85@\xd5\x80\x93X\x86\x08\x9e#uHN\x12\xff\xa6\x9d\x88R\xb5r\x07\xe2~\xb9|\x10*x\x02O\x05\xf5\x1a\xf9z\xb5\x81Z\xee-e\xcf\x1do\xa3\t\xbe\xca\x13X\xcc\xb3\xa71\xb1gU\xb9\x8c\xd1\x1a%\x89\xe3\xe2\xe0\xf5\x0fJ\xf1E(\xb9r\xc8\xc1\xc6D\\pB\x9e\x89\xb3\x88!\xf4+\xe1T\xf8z\x80\x94\x8c\x86l+\x13\xbdH\xc7i\xa2\xb3\x02\xe9h\x01\xcb\xcb\x1ag\xba\x0cum\x14\xe8\xa0\xf6\x8eKJ\x8c\t\xa4\xc6\x06\x80\x9c-G\xd1\xc5\x154\xf1\x90a\xfc\xde\xcdn`\x90\xb9H\xe4\xd4m\n\x11\xd9\xb5\x04\x7f\xe7\x9dl\xe9\xab\x8b\xc8B\x90\xc8\\9\xe4\x84d\xed\xd9'\x84\xdeq\r\xfaV8O\xf8#\xa4v\xf0\x04\xc5\xb0\xcc\x1f\xf3w\x9f'\xfd[\x1ay\x0f\xa1\xfd\xef{\xd6\xaf\xa5\x93\xc6O\r\x88\xe1=\xaf?\x01PK\x01\x02\x14\x03\x14\x00\x00\x00\x08\x00\ti\x8cXFZ\xc1\x0c\x82\x00\x00\x00\xb1\x00\x00\x00\x10\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x80\x01\x00\x00\x00\x00docProps/app.xmlPK\x01\x02\x14\x03\x14\x00\x00\x00\x08\x00\ti\x8cX\xddR\xb3\x7f\xea\x00\x00\x00\xcb\x01\x00\x00\x11\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x80\x01\xb0\x00\x00\x00docProps/core.xmlPK\x01\x02\x14\x03\x14\x00\x00\x00\x08\x00\ti\x8cX\x99\\\x9c#\x10\x06\x00\x00\x9c'\x00\x00\x13\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x80\x01\xc9\x01\x00\x00xl/theme/theme1.xmlPK\x01\x02\x14\x03\x14\x00\x00\x00\x08\x00\ti\x8cX\x04q\xaa\xb1n\x01\x00\x00F\x03\x00\x00\x18\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x80\x81\n\x08\x00\x00xl/worksheets/sheet1.xmlPK\x01\x02\x14\x03\x14\x00\x00\x00\x08\x00\ti\x8cX\x18\xb4\x1cWd\x02\x00\x00\xc0\n\x00\x00\r\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x80\x01\xae\t\x00\x00xl/styles.xmlPK\x01\x02\x14\x03\x14\x00\x00\x00\x08\x00\ti\x8cX\xb7G\xeb\x8a\xc0\x00\x00\x00\x16\x02\x00\x00\x0b\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x80\x01=\x0c\x00\x00_rels/.relsPK\x01\x02\x14\x03\x14\x00\x00\x00\x08\x00\ti\x8cXg\xc5t\x873\x01\x00\x00,\x02\x00\x00\x0f\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x80\x01&\r\x00\x00xl/workbook.xmlPK\x01\x02\x14\x03\x14\x00\x00\x00\x08\x00\ti\x8cX3\xeb\xe3\xba\xad\x00\x00\x00\xfb\x01\x00\x00\x1a\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x80\x01\x86\x0e\x00\x00xl/_rels/workbook.xml.relsPK\x01\x02\x14\x03\x14\x00\x00\x00\x08\x00\ti\x8cX\x9b\x86B\x84\x1b\x01\x00\x00\xd7\x03\x00\x00\x13\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x80\x01k\x0f\x00\x00[Content_Types].xmlPK\x05\x06\x00\x00\x00\x00\t\x00\t\x00>\x02\x00\x00\xb7\x10\x00\x00\x00\x00"


table_definition_json_array = [["Col1", "Col2", "Col3"], ["test1", 0.5, False], ["test2", None, True]]

# this is the xlsx representation of the table_definition_json_array above
xlsx_from_json_array_result = b"PK\x03\x04\x14\x00\x00\x00\x08\x00\x99j\x8cXFZ\xc1\x0c\x82\x00\x00\x00\xb1\x00\x00\x00\x10\x00\x00\x00docProps/app.xmlM\x8eM\x0b\xc20\x10D\xffJ\xe9\xddnU\xf0 1 \xd4\xa3\xe0\xc9{H76\x90dCv\x85\xfc|S\xc1\x8f\xdb<\xde0\x8c\xba\x15\xcaX\xc4#w5\x86\xc4\xa7~\x11\xc9G\x00\xb6\x0bF\xc3C\xd3\xa9\x19G%\x1aiX\x1e@\xcey\x8b\x13\xd9g\xc4$\xb0\x1b\xc7\x03`\x15L3\xce\x9b\xfc\x1d\xec\xb5:\xe7\x1c\xbc5\xe2)\xe9\xab\xb7\x85\x98\x9ct\x97j1(\xf8\x97k\xf3\x8e\x85\xd7\xbc\x1f\xb6o\xf9a\x05\xbf\x93\xfa\x05PK\x03\x04\x14\x00\x00\x00\x08\x00\x99j\x8cXh\xedm\xda\xea\x00\x00\x00\xcb\x01\x00\x00\x11\x00\x00\x00docProps/core.xml\xa5\x91MO\xc30\x0c\x86\xff\xca\x94{\xeb\xa4\x1b\x1c\xa2\xae\x97\xa1\x9d\x86\x84\xc4$\x10\xb7(\xf1\xb6\x88\xe6C\x89Q\xbb\x7fO[\xb6\x0e\x047\x8e\xf1\xfb\xf8\xb1\xad\xd4:J\x1d\x12>\xa5\x101\x91\xc5\xbc\xe8]\xeb\xb3\xd4q\xcdNDQ\x02d}B\xa7r9\x10~\x08\x0f!9E\xc33\x1d!*\xfd\xae\x8e\x08\x15\xe7\xf7\xe0\x90\x94Q\xa4`\x14\x16q6\xb2\x8b\xd2\xe8Y\x19?R;\t\x8c\x06l\xd1\xa1\xa7\x0c\xa2\x14pc\t\x93\xcb\x7f6L\xc9L\xf6\xd9\xceT\xd7ue\xb7\x9c\xb8a#\x01\xaf\x8f\xbb\xe7i\xf9\xc2\xfaL\xcakdMm\xb4\xd4\t\x15\x85\xd4\x8c\x17\xc5s\xdf\xd6\xf0\xadX_f\x7f\x15\xd0,\x86\t\x92\xce\x11\xd7\xec\x9a\xbc,7\x0f\xfb-k*^\xad\n\xbe*D\xb5\x17BV\\\xde\xf1\xb7\xd1\xf5\xa3\xff&t\xc1\xd8\x83\xfd\x87\xf1*hj\xf8\xf5o\xcd'PK\x03\x04\x14\x00\x00\x00\x08\x00\x99j\x8cX\x99\\\x9c#\x10\x06\x00\x00\x9c'\x00\x00\x13\x00\x00\x00xl/theme/theme1.xml\xedZ[s\xda8\x14~\xef\xaf\xd0xg\xf6m\x0b\xc66\x81\xb6\xb4\x13siv\xdb\xb4\x99\x84\xedN\x1f\x85\x11X\x8dlyd\x91\x84\x7f\xbfG6\x10\xcb\x96\r\xed\x92M\xba\x9b<\x04,\xe9\xfb\xceEG\xe7\xe88y\xf3\xee.b\xe8\x86\x88\x94\xf2x`\xd9/\xdb\xd6\xbb\xb7/\xde\xe0W2$\x11A0\x19\xa7\xaf\xf0\xc0\n\xa5L^\xb5Zi\x00\xc38}\xc9\x13\x12\xc3\xdc\x82\x8b\x08Kx\x14\xcb\xd6\\\xe0[\x1a/#\xd6\xea\xb4\xdb\xddV\x84il\xa1\x18Gd`}^,h@\xd0TQZo_ \xb4\xe5\x1f3\xf8\x15\xcbT\x8de\xa3\x01\x13WA&\xb9\x88\xb4\xf2\xf9l\xc5\xfc\xda\xde>e\xcf\xe9:\x1d2\x81n0\x1bX \x7f\xceo\xa7\xe4NZ\x88\xe1T\xc2\xc4\xc0jg?Vk\xc7\xd1\xd2H\x80\x82\xc9}\x94\x05\xbaI\xf6\xa3\xd3\x15\x082\r;:\x9dX\xcev|\xf6\xc4\xed\x9f\x8c\xca\xdat4m\x1a\xe0\xe3\xf1x8\xb6\xcb\xd2\x8bp\x1c\x04\xe0Q\xbb\x9e\xc2\x9d\xf4l\xbf\xa4A\t\xb4\xa3i\xd0d\xd8\xf6\xda\xae\x91\xa6\xaa\x8dSO\xd3\xf7}\xdf\xeb\x9bh\x9c\n\x8d[O\xd3kw\xdd\xd3\x8e\x89\xc6\xad\xd0x\r\xbe\xf1O\x87\xc3\xae\x89\xc6\xab\xd0t\xebi&'\xfd\xaek\xa4\xe9\x16hBF\xe3\xebz\x12\x15\xb5\xe5@\xd3 \x00Xpv\xd6\xcc\xd2\x03\x96^)\xfau\x94\x1a\xd9\x1d\xbb\xddA\\\xf0X\xee9\x89\x11\xfe\xc6\xc5\x04\xd6i\xd2\x19\x964Fr\x9d\x90\x05\x0e\x007\xc4\xd1LP|\xafA\xb6\x8a\xe0\xc2\x92\xd2\\\x90\xd6\xcf)\xb5P\x1a\x08\x9a\xc8\x81\xf5G\x82!\xc5\xdc\xaf\xfd\xf5\x97\xbb\xc9\xa43z\x9d}:\xcek\x94\x7fi\xab\x01\xa7\xed\xbb\x9b\xcf\x93\xfcs\xe8\xe4\x9f\xa7\x93\xd7MB\xcep\xbc,\t\xf1\xfb#[a\x87'n;\x13r:\x1cgB|\xcf\xf6\xf6\x91\xa5%2\xcf\xef\xf9\n\xebN<g\x1fV\x96\xb0]\xcf\xcf\xe4\x9e\x8cr#\xbb\xdd\xf6X}\xf6OGn#\xd7\xa9\xc0\xb3\"\xd7\x94F$E\x9f\xc8-\xba\xe4\x118\xb5I\r2\x13?\x08\x9d\x86\x98jP\x1c\x02\xa4\t1\x96\xa1\x86\xf8\xb4\xc6\xac\x11\xe0\x13}\xb7\xbe\x08\xc8\xdf\x8d\x88\xf7\xabo\x9a=W\xa1XI\xda\x84\xf8\x10F\x1a\xe2\x9cs\xe6s\xd1l\xfb\x07\xa5F\xd1\xf6U\xbc\xdc\xa3\x97X\x15\x01\x97\x18\xdf4\xaa5,\xc5\xd6x\x95\xc0\xf1\xad\x9c<\x1d\x13\x12\xcd\x94\x0b\x06A\x86\x97$&\x12\xa99~MH\x13\xfe+\xa5\xda\xfe\x9c\xd3@\xf0\x94/$\xfaJ\x91\x8fi\xb3#\xa7t&\xcd\xe83\x1a\xc1F\xaf\x1bu\x87h\xd2<z\xfe\x05\xf9\x9c5\n\x1c\x91\x1b\x1d\x02g\x1b\xb3F!\x84i\xbb\xf0\x1e\xaf$\x8e\x9a\xad\xc2\x11+B>b\x196\x1ar\xb5\x16\x81\xb6q\xa9\x84`Z\x12\xc6\xd1xN\xd2\xb4\x11\xfcY\xac5\x93>`\xc8\xec\xcd\x91u\xce\xd6\x91\x0e\x11\x92^7B>b\xce\x8b\x90\x11\xbf\x1e\x868J\x9a\xed\xa2qX\x04\xfd\x9e^\xc3I\xc1\xe8\x82\xcbf\xfd\xb8~\x86\xd53l,\x8e\xf7G\xd4\x17J\xe4\x0f&\xa7?\xe924\x07\xa3\x9aY\t\xbd\x84Vj\x9f\xaa\x874>\xa8\x1e2\n\x05\xf1\xb9\x1e>\xe5zx\n7\x96\xc6\xbcP\xae\x82{\x01\xff\xd1\xda7\xc2\xab\xf8\x82\xc09\x7f.}\xcf\xa5\xef\xb9\xf4=\xa1\xd2\xb77#}g\xc1\xd3\x8b[\xdeFn[\xc4\xfb\xae1\xda\xd74.(cWr\xcd\xc8\xc7T\xaf\x93)\xd89\x9f\xc0\xec\xfdh>\x9e\xf1\xed\xfa\xd9$\x84\xaf\x9aY-#\x16\x90K\x81\xb3A$\xb8\xfc\x8b\xca\xf0*\xc4\t\xe8d[%\t\xcbT\xd3e7\x8a\x12\x9eB\x1bn\xe9S\xf5J\x95\xd7\xe5\xaf\xb9(\xb8<[\xe4\xe9\xaf\xa1t>,\xcf\xf9<_\xe7\xb4\xcd\x0b3C\xb7rK\xea\xb6\x94\xbe\xb5&8J\xf4\xb1\xccpN\x1e\xcb\x0c;g<\x92\x1d\xb6w\xa0\x1d5\xfb\xf6]v\xe4#\xa50S\x97C\xb8\x1aB\xbe\x03m\xba\x9d\xdc:8\x9e\x98\x91\xb9\n\xd3R\x90o\xc3\xf9\xe9\xc5x\x1a\xe29\xd9\x04\xb9}\x98Wm\xe7\xd8\xd1\xd1\xfb\xe7\xc1Q\xb0\xa3\xef<\x96\x1d\xc7\x88\xf2\xa2!\xee\xa1\x86\x98\xcf\xc3C\x87y{_\x98g\x95\xc6P4\x14ml\xac$,F\xb7`\xb8\xd7\xf1,\x14\xe0d`-\xa0\x07\x83\xafQ\x02\xf2RU`1[\xc6\x03+\x90\xa2|L\x8cE\xe8p\xe7\x97\\_\xe3\xd1\x92\xe3\xdb\xa6e\xb5n\xaf)w\x19m\"R9\xc2i\x98\x13g\xab\xca\xdee\xb1\xc1U\x1d\xcfU[\xf2\xb0\xbej=\xb4\x15N\xcf\xfeY\xad\xc8\x9f\x0c\x11N\x16\x0b\x12Hc\x94\x17\xa6J\xa2\xf3\x19S\xbe\xe7+I\xc4U8\xbfE3\xb6\x12\x97\x18\xbc\xe3\xe6\xc7qNS\xb8\x12v\xb6\x0f\x022\xb9\xbb9\xa9ze1g\xa6\xf2\xdf-\x0c\t,[\x88Y\x12\xe2M]\xed\xd5\xe7\x9b\x9c\xaez\"v\xfa\x97w\xc1`\xf2\xfdp\xc9G\x0f\xe5;\xe7_\xf4]C\xae~\xf6\xdd\xe3\xfan\x93;HL\x9cy\xc5\x11\x01tE\x02#\x95\x1c\x06\x16\x172\xe4P\xee\x92\x90\x06\x13\x01\xcd\x94\xc9D\xf0\x02\x82d\xa6\x1c\x80\x98\xfa\x0b\xbd\xf2\x0c\xb9)\x15\xce\xad>9\x7fE,\x83\x86N^\xd2%\x12\x14\x8a\xb0\x0c\x05!\x17r\xe3\xef\xef\x93jw\x8c\xd7\xfa,\x81m\x84T2d\xd5\x17\xcaC\x89\xc1=3rC\xd8T%\xf3\xae\xda&\x0b\x85\xdb\xe2T\xcd\xbb\x1a\xbe&`K\xc3zn\x9d-'\xff\xdb^\xd4=\xb4\x17=F\xf3\xa3\x99\xe0\x1e\xb3\x87s\x9bz\xb8\xc2E\xac\xffX\xd6\x1e\xf92\xdf9p\xdb:\xde\x03^\xe6\x13,C\xa4~\xc1}\x8a\x8a\x80\x11\xabb\xbe\xba\xafO\xf9%\x9c;\xb4{\xf1\x81 \x9b\xfc\xd6\xdb\xa4\xf6\xdd\xe0\x0c|\xd4\xabZ\xa5d+\x11?K\x07|\x1f\x92\x06c\x8c[\xf44_\x8f\x14b\xad\xa6\xb1\xad\xc6\xda1\x0cy\x80X\xf3\x0c\xa1f8\xdf\x87E\x9a\x1a3\xd5\x8b\xac9\x8d\noA\xd5@\xe5?\xdb\xd4\rh\xf6\r4\x1c\x91\x05^1\x99\xb66\xa3\xe4N\n<\xdc\xfe\xef\r\xb0\xc2\xc4\x8e\xe1\xed\x8b\xbf\x01PK\x03\x04\x14\x00\x00\x00\x08\x00\x99j\x8cX\t\xf8\xfa\x7fm\x01\x00\x004\x03\x00\x00\x18\x00\x00\x00xl/worksheets/sheet1.xml}S]O\xc20\x14\xfd+K\x7f\x00\x1d[Pc\xb6%\x821\xfa`B \xeas7\xee\xb6\x86v\x9d\xed\x85\xe9\xbf\xb7\xed\xb0\x19\x06y\xe2~\x9c{\xce\xe9\xee%\x1b\x94\xde\x9b\x16\x00\xa3/):\x93\x93\x16\xb1\xbf\xa7\xd4T-Hff\xaa\x87\xcevj\xa5%C\x9b\xea\x86\x9a^\x03\xdb\xf9!)h\x12\xc77T2\xde\x91\"\xf3\xb5\xb5.2u@\xc1;X\xeb\xc8\x1c\xa4d\xfa{\tB\r9\x99\x93\xdf\xc2\x867-\xfa\x02-\xb2\x9e5\xb0\x05|\xeb\xed\x80Mi\xe0\xf1\xc1;\x87\xc1L\xe2\xc8y.\x95\xda\xbb\xe4e\x97\x93\xd8I\x83\x80\n\xb9\xea\"f\x7f\x8e\xb0\x02!r\xf2\xe0\x04?5\xd4c\x18\xb8\xdd\xe44\xfe\xa5\x7f\xf2\xcf\xb4.Jf`\xa5\xc4\x07\xdfa\x9b\x93;\x12\xed\xa0f\x07\x81\x1b5<\xc3\xc9\xfa\xc2\x13\xfa\xb9G\x86\xac\xc8\xb4\x1a\"\xed\xdeTd\x95\x0b\x9c\xa4\x05\xf2\xce}\x8b-j[\xe7V\t\x0b\xcb<\xcf(Z\x07.\xa7\xd5\t\xbf\xbc\x82O.\xe0WW\xf0\xe99\x9eZo\xc1`\x12\x0c&\xff\x10 \x18\xbc\xe8p\x1cp\xbb>\x16\xf1l\x91\xd1\xe3\xd4\xcf\xd8-\xc7n\xe8\x9di\xa7A;\xbd\xa2}\xf1\xb5\xe9\x84}\xfe\x87\x9dN\xd6\xe0\xae\xe9\x95\xe9\x86w&\x12P\xdb\x99xvk\x97\xa5\xc7\xbd\x8d\t\xaa\xde__\xa9\x10\x95\xf4ak\xaf\x1a\xb4\x03\xd8~\xad\x14\x86\xc4\xddM\xf8\xa3\x14?PK\x03\x04\x14\x00\x00\x00\x08\x00\x99j\x8cX\xd2\x05\xf1FR\x02\x00\x00G\n\x00\x00\r\x00\x00\x00xl/styles.xml\xddV\xdb\x8a\xdb0\x10\xfd\x15\xe3\x0f\xa8\x93\x98\x9a\xb8$y\xa8!Ph\xcb\xc2\xeeC_\xe5XN\x04\xba\xb8\xb2\xbc$\xfd\xfaj$\xe7\xb6\x9b\xe3R\xfaV\x9b\xe0\x999:3g\xa41\xce\xaaw'\xc9\x9f\x0f\x9c\xbb\xe4\xa8\xa4\xee\xd7\xe9\xc1\xb9\xeeS\x96\xf5\xbb\x03W\xac\xff`:\xae=\xd2\x1a\xab\x98\xf3\xae\xddg}g9kz\")\x99-f\xb3\"SL\xe8t\xb3\xd2\x83\xda*\xd7';3h\xb7Ngi\x92mV\xad\xd1\xd7\xd0<\x8d\x01\xbf\x96)\x9e\xbc2\xb9N+&EmE\\\xcc\x94\x90\xa7\x18_\x84\xc8\xceHc\x13\xe7\xd5p\xa2S\xa8\xff\x15\x17\xccG\x97\xa4\x8e\xb9\x94\xd0\xc6\x86h\x16\xcb\x84G\xef\x13\x0b)/*\x16i\x0clV\x1ds\x8e[\xbd\xf5N$\x85\xe8{l\xb4_N\x9dW\xb1\xb7\xec4_|Lo\x18\xe1\xe1\xcb\xd4\xc66\xdc\xde\xb5\x1bC\x9b\x95\xe4\xad#\x86\x15\xfbC0\x9c\xe9\xe8Q\x1b\xe7\x8c\"\xab\x11lo4\x8bJ\xce\xb4\xd1\xf0\xb9w\\\xcag:\xaf\x1f\xed]\x81c\x9b\xc4\x8d\xff\xd2\x84=\xa7\x8e\xcf\xa6W5\x9a1\xcd\xe8P\x81\xdbt1\xf9\xbf\xe7\xed\xc4\xabq\x9f\x07\xdf\x90\x0e\xfe\xcf\xc18\xfedy+\x8e\xc1?\xb6o\x04\\j\x07%w\xe5/\xd1\x84Fe\x9d~\xa7\x11\x9479\xeaAH'\xf4\xe8\x1dD\xd3p\xfd\xbe;\x9f\xdf\xb1\xda\x0f\xf9]\x01\xbf\xaa\xe1-\x1b\xa4{\xb9\x80\xeb\xf4j\x7f\xe3\x8d\x18TyY\xf5D\x8d\x8d\xab\xae\xf6W:\xcayq\x9dS_L\xe8\x86\x1fyS\x8d\xae\xdd\xd7\xc1L\xbc\xe1\xcb\x8eW`\xbc\x85\xb6\xe1\x02\x10dE\x10@\x04\xc2ZP\x06dE\x1e\xac\xf5?\xf6\xb5\xc4}E\x10*\\>\x86\x96\x98\xb5\xc4\xac\xc8{\x08U\xe1\x86\xb5\x00\xab\xf4\x17h\xb9,\xf3\xbc(\xe0\xf6V\xd5c\x19\x15\xdc\xc3\xa2\xa0\x1fH\x08\x15\x12\x07\xd6\xa2j\x7f\xbb\xf3\x13\x03016\x7f\x98\rx\xca\x93c\x03[\x9e\x18Q\xd8\xf2\xc4\xce\x13\x04\xf6\x908e\t\x06\x00\xd6\"\x0e<\x148Q$\x02\xd4\xa2Q\x03\xac<\xa7s\x86\n\xe1k>\x01\x95%\x84hH\xc1\xf4\x16\x05\xda\xa8\x82np^\xf0%\xca\xf3\xb2\x04\x10\x81@F\x9eC\x88^\xd8\t\x08\xca !\x10\xca\xf3\xf8!}\xf3=\xcb\xce\xdf\xb9\xec\xfa\xd7q\xf3\x1bPK\x03\x04\x14\x00\x00\x00\x08\x00\x99j\x8cX\xb7G\xeb\x8a\xc0\x00\x00\x00\x16\x02\x00\x00\x0b\x00\x00\x00_rels/.rels\x9d\x92Kn\x021\x0c@\xaf\x12e_L\xa9\xc4\x021\xac\xd8\xb0C\x88\x0b\xb8\x89\xe7\xa3\x99\xc4\x91c\xc4\xf4\xf6\x8d\xd8\xc0 h\x11K\xff\x9e\x9e-\xaf\x0f4\xa0v\x1cs\xdb\xa5l\xc60\xc4\\\xd9V5\xad\x00\xb2k)`\x9eq\xa2X*5K@-\xa14\x90\xd0\xf5\xd8\x10,\xe6\xf3%\xc8-\xc3n\xd6\xb7Ls\xfcI\xf4\n\x91\xeb\xbas\xb4ew\n\x14\xf5\x01\xf8\xae\xc3\x9a#JCZ\xd9q\x803K\xff\xcd\xdc\xcf\n\xd4\x9a\x9d\xaf\xac\xec\xfc\xa75\xf0\xa6\xcc\xf3\xf5 \x90\xa2GEp,\xf4\x91\xa4L\x8bv\x94\xaf>\x9e\xdd\xbe\xa4\xf3\xa5cb\xb4x\xdf\xe8\xff\xf3\xd0\xa8\x14=\xf9\xbf\x9d0\xa5\x89\xd2\xd7E\t&o\xb0\xf9\x05PK\x03\x04\x14\x00\x00\x00\x08\x00\x99j\x8cX\xe4\xb0k\xee0\x01\x00\x00(\x02\x00\x00\x0f\x00\x00\x00xl/workbook.xml\x8d\x90\xd1N\xc30\x0cE\x7f\xa5\xca\x07\xd0n\x82IL\xeb^\x98\x80I\x08\x10C{\xcfZw\xb5\x96\xc4\x95\xe3n\xb0\xaf'I)L\xe2\x85'\xc7\xd7\xd6\xc9\xbd^\x9c\x88\x0f;\xa2C\xf6a\x8d\xf3s.U+\xd2\xcd\xf3\xdcW-X\xed\xaf\xa8\x03\x17f\r\xb1\xd5\x12Z\xde\xe7\xd44X\xc1\x8a\xaa\xde\x82\x93|Z\x14\xb3\x9c\xc1hAr\xbe\xc5\xce\xab\x81\xf6\x1f\x96\xef\x18t\xed[\x00\xb1f@Y\x8dN-\x17\xa3\xb3W\xce\xf2\xcb\x8e\x04\xaa\xf8ST\xa3\xb2E8\xf9\xdf\x85\xd8fG\xf4\xb8C\x83\xf2Y\xaa\xf46\xa02\x8b\x0e-\x9e\xa1.U\xa12\xdf\xd2\xe9\x91\x18\xcf\xe4D\x9bM\xc5dL\xa9&\xc3`\x0b,X\xfd\x917\xd1\xe6\xbb\xde\xf9\xa4\x88\xde\xbd\xc5\xcc\xa5\x9a\x15\x01\xd8 {I\x1b\x89\xaf\x83\xc9#\x84\xe5\xa1\xeb\x85\xee\xd1\x08\xf0J\x0b<0\xf5\x1d\xba}\xc2\x84\x18\xf9E\x8et\x8a\xb1fN[(U\xa2F\x0b\xa1\xac\xeb\xc1\x8e\x04\xceE8\x9ec\x18\xf0\xba\xfe&\x8e\x98\x1a\x1atP?\x07\x8e\x8f\x83\x10\xaa\n\x17\x8d%\x91\xa6\xd77\x93\xdb`\xbe7\xe6.h/\xee\x89t\xfd\xe3k<\xea\xf2\x0bPK\x03\x04\x14\x00\x00\x00\x08\x00\x99j\x8cX3\xeb\xe3\xba\xad\x00\x00\x00\xfb\x01\x00\x00\x1a\x00\x00\x00xl/_rels/workbook.xml.rels\xb5\x91=\x0e\x830\x0c\x85\xaf\x12\xe5\x00\x18\xa8\xd4\xa1\x02\xa6.\xac\x15\x17\x88\x82\xf9\x11\x81D\xb1\xab\xc2\xed\x1b\xc1\x00H\x1d\xba0Y\xcf\x96\xbf\xf7dg/4\x8a{;Q\xd7;\x12\xf3h&\xcae\xc7\xec\x1e\x00\xa4;\x1c\x15E\xd6\xe1\x14&\x8d\xf5\xa3\xe2 }\x0bN\xe9A\xb5\x08i\x1c\xdf\xc1\x1f\x19\xb2\xc8\x8eLQ-\x0e\xff!\xda\xa6\xe95>\xad~\x8f8\xf1\x0f0|\xac\x1f\xa8Cd)*\xe5[\xe4\\\xc2l\xf66\xc1Z\x92(\x90\xa5(\xeb\\\xfa\xb2N\xa4\x80\xcb\x12\x11/\x06i\x8f\xb3\xe9\x93\x7fz\xa5?\x87]\xdc\xedW\xb95\xcfG\xb8\xad!\xe0\xf4\xeb\xe2\x0bPK\x03\x04\x14\x00\x00\x00\x08\x00\x99j\x8cX\x9b\x86B\x84\x1b\x01\x00\x00\xd7\x03\x00\x00\x13\x00\x00\x00[Content_Types].xml\xad\x93\xcfN\xc30\x0c\xc6_\xa5\xeauj38p@\xeb.\x8c+\xec\xc0\x0b\x84\xc4]\xa3\xe6\x9fboto\x8f\xdb\xb2J\xa0\xb1\r\x95K\xa3\xc6\xf6\xf7s\xfc%\xab\xb7c\x04\xcc:g=VyC\x14\x1f\x85@\xd5\x80\x93X\x86\x08\x9e#uHN\x12\xff\xa6\x9d\x88R\xb5r\x07\xe2~\xb9|\x10*x\x02O\x05\xf5\x1a\xf9z\xb5\x81Z\xee-e\xcf\x1do\xa3\t\xbe\xca\x13X\xcc\xb3\xa71\xb1gU\xb9\x8c\xd1\x1a%\x89\xe3\xe2\xe0\xf5\x0fJ\xf1E(\xb9r\xc8\xc1\xc6D\\pB\x9e\x89\xb3\x88!\xf4+\xe1T\xf8z\x80\x94\x8c\x86l+\x13\xbdH\xc7i\xa2\xb3\x02\xe9h\x01\xcb\xcb\x1ag\xba\x0cum\x14\xe8\xa0\xf6\x8eKJ\x8c\t\xa4\xc6\x06\x80\x9c-G\xd1\xc5\x154\xf1\x90a\xfc\xde\xcdn`\x90\xb9H\xe4\xd4m\n\x11\xd9\xb5\x04\x7f\xe7\x9dl\xe9\xab\x8b\xc8B\x90\xc8\\9\xe4\x84d\xed\xd9'\x84\xdeq\r\xfaV8O\xf8#\xa4v\xf0\x04\xc5\xb0\xcc\x1f\xf3w\x9f'\xfd[\x1ay\x0f\xa1\xfd\xef{\xd6\xaf\xa5\x93\xc6O\r\x88\xe1=\xaf?\x01PK\x01\x02\x14\x03\x14\x00\x00\x00\x08\x00\x99j\x8cXFZ\xc1\x0c\x82\x00\x00\x00\xb1\x00\x00\x00\x10\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x80\x01\x00\x00\x00\x00docProps/app.xmlPK\x01\x02\x14\x03\x14\x00\x00\x00\x08\x00\x99j\x8cXh\xedm\xda\xea\x00\x00\x00\xcb\x01\x00\x00\x11\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x80\x01\xb0\x00\x00\x00docProps/core.xmlPK\x01\x02\x14\x03\x14\x00\x00\x00\x08\x00\x99j\x8cX\x99\\\x9c#\x10\x06\x00\x00\x9c'\x00\x00\x13\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x80\x01\xc9\x01\x00\x00xl/theme/theme1.xmlPK\x01\x02\x14\x03\x14\x00\x00\x00\x08\x00\x99j\x8cX\t\xf8\xfa\x7fm\x01\x00\x004\x03\x00\x00\x18\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x80\x81\n\x08\x00\x00xl/worksheets/sheet1.xmlPK\x01\x02\x14\x03\x14\x00\x00\x00\x08\x00\x99j\x8cX\xd2\x05\xf1FR\x02\x00\x00G\n\x00\x00\r\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x80\x01\xad\t\x00\x00xl/styles.xmlPK\x01\x02\x14\x03\x14\x00\x00\x00\x08\x00\x99j\x8cX\xb7G\xeb\x8a\xc0\x00\x00\x00\x16\x02\x00\x00\x0b\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x80\x01*\x0c\x00\x00_rels/.relsPK\x01\x02\x14\x03\x14\x00\x00\x00\x08\x00\x99j\x8cX\xe4\xb0k\xee0\x01\x00\x00(\x02\x00\x00\x0f\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x80\x01\x13\r\x00\x00xl/workbook.xmlPK\x01\x02\x14\x03\x14\x00\x00\x00\x08\x00\x99j\x8cX3\xeb\xe3\xba\xad\x00\x00\x00\xfb\x01\x00\x00\x1a\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x80\x01p\x0e\x00\x00xl/_rels/workbook.xml.relsPK\x01\x02\x14\x03\x14\x00\x00\x00\x08\x00\x99j\x8cX\x9b\x86B\x84\x1b\x01\x00\x00\xd7\x03\x00\x00\x13\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x80\x01U\x0f\x00\x00[Content_Types].xmlPK\x05\x06\x00\x00\x00\x00\t\x00\t\x00>\x02\x00\x00\xa1\x10\x00\x00\x00\x00"


def test_xlsx_from_json(client: TestClient):
    res = client.post("/api/xlsx/from_json", json=table_defintion_json)
    xlsx_file = res.content
    assert res.status_code == 200
    assert isinstance(xlsx_file, (bytes, bytearray))


def test_xlsx_to_json(client: TestClient):
    res = client.post("/api/xlsx/to_json", files={"file": xlsx_from_json_result})
    assert res.status_code == 200
    # Result must be the same as the input for table download
    assert res.json() == table_defintion_json


def test_xlsx_from_json_array(client: TestClient):
    res = client.post("/api/xlsx/from_json_array", json=table_definition_json_array)
    xlsx_file = res.content
    assert res.status_code == 200
    assert isinstance(xlsx_file, (bytes, bytearray))


def test_xlsx_to_json_array(client: TestClient):
    res = client.post("/api/xlsx/to_json_array", files={"file": xlsx_from_json_array_result})
    assert res.status_code == 200
    # Result must be the same as the input for table download
    assert res.json() == table_definition_json_array
